//-------------------------------------------------------------------------------------------------
// ThePhysicsSystem.hpp (engine)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_ThePhysicsSystem_
#define _include_ThePhysicsSystem_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "engineCommon.hpp"
#include "Vector2.hpp"


//-------------------------------------------------------------------------------------------------
// PhysObjShapeType2
// 
// Basic 2D physics shape primitives
//-------------------------------------------------------------------------------------------------
enum PhysObjShapeType2
{
	PHYSOBJ_SHAPETYPE_POINT2,			// 2D point
	PHYSOBJ_SHAPETYPE_LINESEGMENT2,		// 2D line segment
	PHYSOBJ_SHAPETYPE_AABB2,			// 2D axis-aligned bounding box
//	PHYSOBJ_SHAPETYPE_OBB2,				// 2D oriented bounding box
//	PHYSOBJ_SHAPETYPE_DISC2,			// 2D round disc
//	PHYSOBJ_SHAPETYPE_CAPSULE2,			// 2D capsule (swept disc)
//	PHYSOBJ_SHAPETYPE_CONVEXPOLY2,		// 2D convex polygon
//	PHYSOBJ_SHAPETYPE_POLYGON2,			// 2D general (concave or convex) polygon
	NUM_PHYSOBJ_SHAPETYPES
};


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		PhysObjBase2
//
///////////////////////////////////////////////////////////////////////////////////////////////////
class PhysObjBase2
{
private:
	PhysObjShapeType2	_shapeType;
	Vector2				_vel;
	Vector2				_pos;
	Vector2				_oldPos;
//	float				_rotationRadians;
//	float				_angularVelocityRadiansPerSecond;
//	float				_mass;

public:
	PhysObjBase2() {};
	virtual ~PhysObjBase2() {};
};


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		ThePhysicsSystem
//
///////////////////////////////////////////////////////////////////////////////////////////////////
class ThePhysicsSystem
{
private:
	/// Static members
	static bool _isInitialized;

public:
	/// Construction, initialization, and singleton methods
	ThePhysicsSystem(); // default constructor
	~ThePhysicsSystem(); // destructor

	void Startup();
	void Shutdown();

	/// Public methods
};


//-------------------------------------------------------------------------------------------------
// Global singleton instance
//-------------------------------------------------------------------------------------------------
extern ThePhysicsSystem thePhysicsSystem;


#endif // _include_ThePhysicsSystem_
