#ifndef __BALL_HPP__
#define __BALL_HPP__

#include <Vector2.hpp>
#include "Animation.hpp"
#include "MapArea.hpp"

class Ball
{
public:

	Ball( const std::string& tgaBall, const std::string& tgaHighlight );
	~Ball();

	void Update();
	void Draw();
//	void ResolveCollisionWithLinedef( MapLinedef* linedef, const Vector2& originalMovement, float collideFraction, float ballEnergyFraction );
//	void ResolveCollisionWithVertex( MapVertex* vertex, const Vector2& originalMovement, float collideFraction, float ballEnergyFraction );
	bool ResolveInterpenetrations();
	void ResolveLinedefInterpenetration( MapLinedef* linedef );
	bool ResolveVertexInterpenetrations();
	bool ResolveLinedefInterpenetrations();
	void ResolveVertexInterpenetration( const Vector2& vertexPos );
	void ResolveVertexInterpenetration( MapVertex* vertex );
//	void RunPhysicsTime();

	void RunPhysics();
	void RunPartialPhysics( float& timeLeft );
	void ResolveCollisionWithVertex( const LineSegment2& discSweep, MapVertex* vertex, float timeFraction, float& timeLeft );
	void ResolveCollisionWithLinedef( const LineSegment2& discSweep, MapLinedef* linedef, float timeFraction, float& timeLeft );
	void ResolveCollisionWithLineSegment( const LineSegment2& discSweep, const LineSegment2& lineSeg, float timeFraction, float& timeLeft );
	void ResolveNoCollision( const LineSegment2& sweep, float& timeLeft );

public: // PUBLIC data for convenience

	Animation		m_animHighlight;
	Animation		m_animBall;
	Vector2			m_pos;
	Vector2			m_vel;
	float			m_angleDegrees;
	float			m_rotationalVelocity;
	float			m_radius;
//	float			m_physicsTimeRemainingToResolveThisFrame;
};

#endif //__BALL_HPP__