//-------------------------------------------------------------------------------------------------
// Grid.hpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_Grid_
#define _include_Grid_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "gameCommon.hpp"


const float DEFAULT_GRID_SIZE		= 64.0f;
const float DEFAULT_MIN_GRID_SIZE	= 1.0f;
const float DEFAULT_MAX_GRID_SIZE	= 1024.0f;


enum
{
	MIN_GRID_SIZE		= 1,
	MAX_GRID_SIZE		= 1024,
};


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		Grid
// 
///////////////////////////////////////////////////////////////////////////////////////////////////
class Grid
{
private:
public:
	/// Constructors / destructors
	Grid( float gridSize = DEFAULT_GRID_SIZE, float minGridSize = DEFAULT_MIN_GRID_SIZE, float maxGridSize = DEFAULT_MAX_GRID_SIZE, bool snapToGrid = true );
	~Grid();

	const Vector2 FindClosestGridPointToWorldCoordinates( const Vector2& worldCoords );
	void DecreaseGridSize();
	void IncreaseGridSize();
	void SetGridSize( float newGridSize );
	static float GetGridEpsilon();

	float			m_gridSize;
	float			m_minGridSize;
	float			m_maxGridSize;
	bool			m_snapToGrid;
};


#endif // _include_Grid_
