
#include "pch.hpp"
#include "gameCommon.hpp"
#include "item.hpp"

Item::Item( MapObject* mapObjectArg )
:	mapObject( mapObjectArg ),
	pos( mapObject->m_pos ),
	radius( 24 ),
	_anim( 0 )
{
	ASSERT( mapObjectArg );

	std::string unusedValue;
	if( mapObject->m_properties.GetKeyValue( "BALLSPAWN", unusedValue ) )
	{
		return;
	}

	std::string spriteName;
	if( !mapObject->m_properties.GetKeyValue( "SPRITE", spriteName ) )
	{
		// use default
		spriteName = "collection01";
	}

	std::string spriteFilename( "data/sprites/" );
	spriteFilename += spriteName;
	spriteFilename += ".tga";
	_anim = new Animation( spriteFilename );

}

Item::~Item()
{
}


void Item::Draw()
{
	if( !_anim )
	{
		return;
	}

	glEnable( GL_BLEND );
	glBlendFunc( GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA );
	_anim->Draw( pos, Vector2::ONE, 0, Rgba::WHITE );
}

bool Item::IsCollectable() const
{
	std::string value;
	if( !mapObject->m_properties.GetKeyValue( "COLLECT", value ) )
	{
		return true;
	}

	if( !stricmp( value.c_str(), "0" ) )
	{
		return false;
	}

	return true;
}

bool Item::IsBallSpawn( void ) const
{
	std::string value ;
	if ( mapObject->m_properties.GetKeyValue( "BALLSPAWN", value ) )
	{
		return true ;
	}
	return false ;
}