#ifndef __MAP_HPP__
#define __MAP_HPP__

#include <Texture.hpp>
#include "MapArea.hpp"
#include "Item.hpp"
#include "Wall.hpp"
#include "Ball.hpp"


extern bool g_TEMP_physicsDebugMode;
extern bool g_TEMP_isPhysicsFrozen;
extern bool g_TEMP_enableFreezingPhysics;


class Map
{
public:

	Map( const std::string& mapName );
	~Map();

//	MapLinedef* CheckForCollisionAgainstLinedefs( const Vector2& pos, float radius, const Vector2& movement, float& timeFraction );
//	MapVertex* CheckForCollisionAgainstVertexes( const Vector2& pos, float radius, const Vector2& movement, float& timeFraction );

	MapVertex* CheckForVertexCollision( const LineSegment2& discSweep, float radius, float& timeFraction );
	MapLinedef* CheckForLinedefCollision( const LineSegment2& discSweep, float radius, float& timeFraction );
	Item* CheckForCollisionAgainstItems( const Vector2& pos, float radius, const Vector2& movement, std::list< Item* >& collideItems );
	bool HackTraceMovingDiscAndLineSegmentCollide2d( const LineSegment2& discSweep, float radius, const LineSegment2& lineSeg, float& traceFraction );

	void Draw();
	void RemoveItem( Item* item );

public:

//	std::string				tgaFilename;
//	std::string				mapFilename;
//	std::string				mapName;
	MapArea					mapArea;
	std::vector< Item* >	items;
	std::vector< Wall* >	walls;
	int						collectableItemsRemain;

protected:

	Texture			_texBackdrop;
};

#endif //__MAP_HPP__