//-------------------------------------------------------------------------------------------------
// MapElement.hpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_MapElement_
#define _include_MapElement_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "gameCommon.hpp"


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		MapElement
// 
///////////////////////////////////////////////////////////////////////////////////////////////////
class MapElement
{
private:
public:
	enum ElementType
	{
		ELEMENT_TYPE_UNDEFINED,
		ELEMENT_TYPE_VERTEX,
		ELEMENT_TYPE_LINEDEF,
		ELEMENT_TYPE_OBJECT,
	};

	MapElement();
	virtual ~MapElement();

	virtual void Translate( const Vector2& translation ) = 0;

	unsigned int				m_highlightFrameNumber;	// currently highlighted if this matches the current frame number
	bool						m_isSelected;
	bool						m_isMarked;
	ElementType					m_type;
};


#endif // _include_MapElement_
