//-------------------------------------------------------------------------------------------------
// MapLinedef.hpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_MapLinedef_
#define _include_MapLinedef_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "MapVertex.hpp"
#include "MapProperties.hpp"
#include "gameCommon.hpp"


class MapLinedef;


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		MapLinedef
// 
///////////////////////////////////////////////////////////////////////////////////////////////////
class MapLinedef : public MapElement
{
private:
public:
	/// Members
	MapVertex*		m_start;		// the vertex at the start of the line segment
	MapVertex*		m_end;			// the vertex at the end of the line segment
	Vector2			m_normal;		// x,y also serve as A,B in the line equation Ax + By - C = 0
	float			m_offset;		// the constant C in the line equation Ax + By - C = 0
	float			m_length;		// the distance between the start and end points of the line segment
	MapProperties	m_properties;	// key-value pair properties


	/// Methods
	MapLinedef( MapVertex* start, MapVertex* end );
	~MapLinedef();

	virtual void Translate( const Vector2& translation );
};


#endif // _include_MapLinedef_
