//-------------------------------------------------------------------------------------------------
// MapProperties.cpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#include "pch.hpp"
#include "MapProperties.hpp"


//-------------------------------------------------------------------------------------------------
// Destructor()
//-------------------------------------------------------------------------------------------------
MapProperties::~MapProperties()
{
}


//-------------------------------------------------------------------------------------------------
// Constructor
//-------------------------------------------------------------------------------------------------
MapProperties::MapProperties()
{
}


//-------------------------------------------------------------------------------------------------
// SetKeyValue
//-------------------------------------------------------------------------------------------------
void MapProperties::SetKeyValue( const std::string& key, const std::string& value )
{
	m_keyValuePairs[ key ] = value;
}


//-------------------------------------------------------------------------------------------------
// GetKeyValue
//-------------------------------------------------------------------------------------------------
bool MapProperties::GetKeyValue( const std::string& key, std::string& value ) const
{
	KeyPairMap::const_iterator found = m_keyValuePairs.find( key );
	if( found == m_keyValuePairs.end() )
	{
		return false;
	}
	else
	{
		value = found->second;
		return true;
	}
}


//-------------------------------------------------------------------------------------------------
// GetNumKeyValues
//-------------------------------------------------------------------------------------------------
int MapProperties::GetNumKeyValues() const
{
	return m_keyValuePairs.size();
}


//-------------------------------------------------------------------------------------------------
// DeleteKey
//-------------------------------------------------------------------------------------------------
void MapProperties::DeleteKey( const std::string& key )
{
	KeyPairMap::iterator found = m_keyValuePairs.find( key );
	if( found == m_keyValuePairs.end() )
	{
		return;
	}

	m_keyValuePairs.erase( found );
}



