//-------------------------------------------------------------------------------------------------
// MapProperties.hpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_MapProperties_
#define _include_MapProperties_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "gameCommon.hpp"


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		MapProperties
// 
///////////////////////////////////////////////////////////////////////////////////////////////////
class MapProperties
{
private:
public:

	struct KeyCompare
	{
		bool operator()( const std::string& s1, const std::string& s2 ) const
		{
			return stricmp( s1.c_str(), s2.c_str() ) < 0;
		}
	};

	typedef std::map< std::string, std::string, KeyCompare > KeyPairMap;
//	std::map< std::string, std::string, KeyCompare >	m_keyValuePairs;
	KeyPairMap m_keyValuePairs;

	MapProperties();
	~MapProperties();

	int GetNumKeyValues() const;
	bool GetKeyValue( const std::string& key, std::string& value ) const;
	void SetKeyValue( const std::string& key, const std::string& value );
	void DeleteKey( const std::string& key );
};


#endif // _include_MapProperties_
