//-------------------------------------------------------------------------------------------------
// Options.hpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_Options_
#define _include_Options_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
//#include "DoomEntity.hpp"
//#include "DoomLinedef.hpp"
#include "gameCommon.hpp"


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		Options
// 
///////////////////////////////////////////////////////////////////////////////////////////////////
class Options
{
private:
	static Options*	s_singletonPtr;

public:
	static Options* GetSingleton() { return s_singletonPtr; }

	Options( const char* optionsFilePath );
	~Options();

	void SetToDefaults();

	std::string		m_filePath;
	bool			m_debugDrawHallOfMirrorsCheck;
	bool			m_debugDrawMouseCursorRing;
	float			m_xyScrollSpeed;
	bool			m_xyScrollInvertedX;
	bool			m_xyScrollInvertedY;
	float			m_minVertexSelectWorldDist;
	float			m_maxXYSelectScreenDist;
	Rgba			m_gridLineColor;
	Rgba			m_gridDotColor;
	Rgba			m_linedefColor;
	Rgba			m_linedefHighlightColorFg;
	Rgba			m_linedefHighlightColorBg;
	Rgba			m_linedefSelectionColorFg;
	Rgba			m_linedefSelectionColorBg;
	Rgba			m_linedefHighlightSelectionColorFg;
	Rgba			m_linedefHighlightSelectionColorBg;
	Rgba			m_protoLinedefColor;
	Rgba			m_xyClearColor;
	Rgba			m_closestGridPointColor;
	Rgba			m_vertexColor;
	Rgba			m_vertexHighlightColorFg;
	Rgba			m_vertexHighlightColorBg;
	Rgba			m_vertexSelectionColorFg;
	Rgba			m_vertexSelectionColorBg;
	Rgba			m_vertexHighlightSelectionColorFg;
	Rgba			m_vertexHighlightSelectionColorBg;
	Rgba			m_objectColor;
	Rgba			m_objectHighlightColorFg;
	Rgba			m_objectHighlightColorBg;
	Rgba			m_objectSelectionColorFg;
	Rgba			m_objectSelectionColorBg;
	Rgba			m_objectHighlightSelectionColorFg;
	Rgba			m_objectHighlightSelectionColorBg;
	Rgba			m_iconColor;
};


#endif // _include_Options_
