//-------------------------------------------------------------------------------------------------
// TheEditor.hpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_TheEditor_
#define _include_TheEditor_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "ViewXY.hpp"
#include "View3d.hpp"
#include "ViewInfo.hpp"
#include "ViewTexture.hpp"
#include "ViewConsole.hpp"
#include "Pane.hpp"
#include "MapArea.hpp"
#include "Options.hpp"
#include "gameCommon.hpp"


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		TheEditor
// 
///////////////////////////////////////////////////////////////////////////////////////////////////
class TheEditor
{
private:
public:
	/// from TheEditor.cpp
	TheEditor(); // default constructor
	~TheEditor(); // destructor
	void PreInit();
	void PostInit();
	void RunFrame();
	void OpenStartupDialog();
	void UpdateEverything();
	void StartEditing();
	void StopEditing();
	void PlayCurrentMap();
	void EditCurrentMap();
//	static int* StartupDialogProc( HWND hWnd, UINT uInt, WPARAM wParam, LPARAM lParam );

	/// from TheEditor_Input.cpp
	bool ProcessInputEvent( TheInputSystem::inputEventType_e eventType, byte_t key );
	void SetFocus();
	void SetPropertyForHighlightedElements( const std::string& key, const std::string& value );
	void DeletePropertyForHighlightedElements( const std::string& key );
	void LoadMap( const std::string& mapPath );
	void SaveMap( const std::string& mapPath );
	void SetBackgroundImage( const std::string& backgroundImage );
	void LoadUnderlayTexture( const char* texturePath );

	/// from TheEditor_Draw.cpp
	void DrawEverything();
	void DebugDrawHallOfMirrorsCheck();
	void DebugDrawMouseCursorRing();

	/// Member variables
	Pane*			m_rootPane;
//	MapArea*		m_currentArea;
	Options*		m_options;
	bool			m_isEditorActive;
	Texture*		m_underlay;
	float			m_underlayBrightness;
};


//-------------------------------------------------------------------------------------------------
// Externally viewable globals
//-------------------------------------------------------------------------------------------------
extern TheEditor* theEditor;


#endif // _include_TheEditor_
