//-------------------------------------------------------------------------------------------------
// TheEditor_Draw.cpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#include "pch.hpp"
#include "TheEditor.hpp"


//-------------------------------------------------------------------------------------------------
// DrawEverything
//-------------------------------------------------------------------------------------------------
void TheEditor::DrawEverything()
{
	DebugDrawHallOfMirrorsCheck();

	if( m_rootPane )
	{
		m_rootPane->Draw();
	}

	DebugDrawMouseCursorRing();
}


//-------------------------------------------------------------------------------------------------
// DebugDrawMouseCursorRing
//-------------------------------------------------------------------------------------------------
void TheEditor::DebugDrawMouseCursorRing()
{
	if( !m_options->m_debugDrawMouseCursorRing )
	{
		return;
	}

	// DISPLAY DEBUG CIRCLE AROUND THE MOUSE CURSOR
	IntVector2 mousePos = theInputSystem.GetMousePosClientAbsolute();
	glLineWidth( 5.0f );
	theRenderer.ResetViewportAndScissor();
	theRenderer.SetCoordinateSystemToScreenCoordinates2d();
	theRenderer.DrawCircle2d( Vector2( (float)mousePos.x, (float)mousePos.y ), 32.0f, Rgba::WHITE, 32 );
	theRenderer.XYPrintf( 30.0f, 30.0f, "Mouse is at %d, %d", mousePos.x, mousePos.y );
}


//-------------------------------------------------------------------------------------------------
// DebugDrawHallOfMirrorsCheck
//-------------------------------------------------------------------------------------------------
void TheEditor::DebugDrawHallOfMirrorsCheck()
{
	if( !m_options->m_debugDrawHallOfMirrorsCheck )
	{
		return;
	}

	theRenderer.ResetViewportAndScissor();
	theRenderer.SetCoordinateSystemToScreenCoordinates2d();
	double time = 25.0 * theApplication.GetTimeFrameBegan();
	double voob1 = 0.5 + 0.5 * cos( time + 0.0 * (TWO_PI / 3.0) );
	double voob2 = 0.5 + 0.5 * cos( time + 1.0 * (TWO_PI / 3.0) );
	double voob3 = 0.5 + 0.5 * cos( time + 2.0 * (TWO_PI / 3.0) );
	Rgba clearColor;
	clearColor.SetRGBAFloats( (float)voob1, (float)voob2, (float)voob3, 1.0f );
	theRenderer.ClearScreen( clearColor );
}


