//-------------------------------------------------------------------------------------------------
// TheGameInterface.cpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#include "pch.hpp"
#include "TheGameInterface.hpp"
#include "TheGame.hpp"
using namespace std;


//-------------------------------------------------------------------------------------------------
// Global singleton instance
//-------------------------------------------------------------------------------------------------
TheGameInterface theGameInterface;


//-------------------------------------------------------------------------------------------------
// Destructor()
//-------------------------------------------------------------------------------------------------
TheGameInterface::~TheGameInterface()
{
	delete theGame;
}


//-------------------------------------------------------------------------------------------------
// Constructor
//-------------------------------------------------------------------------------------------------
TheGameInterface::TheGameInterface()
{
}


//-------------------------------------------------------------------------------------------------
// PreInit
//-------------------------------------------------------------------------------------------------
void TheGameInterface::PreInit()
{
	theGame = new TheGame();
	theGame->PreInit();
}


//-------------------------------------------------------------------------------------------------
// PostInit
//-------------------------------------------------------------------------------------------------
void TheGameInterface::PostInit()
{
	theGame->PostInit();
}


//-------------------------------------------------------------------------------------------------
// Shutdown
//-------------------------------------------------------------------------------------------------
void TheGameInterface::Shutdown()
{
}


//-------------------------------------------------------------------------------------------------
// RunFrame
//-------------------------------------------------------------------------------------------------
void TheGameInterface::RunFrame()
{
	theGame->RunFrame();
}


//-------------------------------------------------------------------------------------------------
// ProcessCommandLine
//-------------------------------------------------------------------------------------------------
VIRTUAL void TheGameInterface::ProcessCommandLine( string cmdLine )
{
	theGame->ProcessCommandLine( cmdLine );
}


//-------------------------------------------------------------------------------------------------
// ProcessInputEvent
//-------------------------------------------------------------------------------------------------
VIRTUAL const bool TheGameInterface::ProcessInputEvent( const TheInputSystem::inputEventType_e eventType, const byte_t key )
{
	return theGame->ProcessInputEvent( eventType, key );
}
