//-------------------------------------------------------------------------------------------------
// TheGame_Update.cpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#include "pch.hpp"
#include "TheGame.hpp"

//-------------------------------------------------------------------------------------------------
// UpdateEverything
// 
// Process input, update entities, run game logic
//-------------------------------------------------------------------------------------------------
void TheGame::UpdateEverything()
{
	if( IsMapComplete() )
	{
		if( _isSoundEnabled )
		{
			theSoundSystem.PlaySample( SOUND_MAP_COMPLETE_SUCCESS, 0 );
		}
		SetGameState( STATE_MAP_COMPLETE_SUCCESS );
	}

	if( _balls.size() > 0 )
	{
		_balls[0]->Update();
	}
}


void TheGame::UpdateInitialStaging( void )
{
	double currentTime = theApplication.GetTimeFrameBegan();

	if( _forceRotation || _nextRotationUpdateTime <= currentTime )
	{
		_forceRotation = false;

		double timeBetweenUpdates = 0.10;
		if( _isTurboRotation )
		{
			timeBetweenUpdates = 0.01;
		}

		_nextRotationUpdateTime = currentTime + timeBetweenUpdates ;

		_initialRotationAngle	+= _updateRotationDelta ;
		if ( _initialRotationAngle > 360 )	_initialRotationAngle	= 0 ;
		if ( _initialRotationAngle < 0 )	_initialRotationAngle	= 360 ;
	}

	if( _forcePower || _nextPowerUpdateTime <= currentTime )
	{
		_forcePower = false;

		double timeBetweenUpdates = 0.10;
		if( _isTurboPower )
		{
			timeBetweenUpdates = 0.02;
		}

		_nextPowerUpdateTime = currentTime + timeBetweenUpdates ;

		_initialPower			+= _updatePowerDelta ;
		if ( _initialPower > 100 )			_initialPower			= 100 ;
		if ( _initialPower < 0 )			_initialPower			= 0 ;
	}
}



/*
void TheGame::UpdateInitialStaging( void )
{
	double currentTime = theApplication.GetTimeFrameBegan();

	if( !_forceRotation )
	{
		if ( _nextUpdateTime > currentTime ) return ;
	}
	_forceRotation = false;

	double timeBetweenUpdates = 0.10;
	if( _isTurboRotation )
	{
		timeBetweenUpdates = 0.01;
	}

	_nextUpdateTime = currentTime + timeBetweenUpdates ;

	_initialRotationAngle	+= _updateRotationDelta ;
	if ( _initialRotationAngle > 360 )	_initialRotationAngle	= 0 ;
	if ( _initialRotationAngle < 0 )	_initialRotationAngle	= 360 ;

	_initialPower			+= _updatePowerDelta ;
	if ( _initialPower > 100 )			_initialPower			= 100 ;
	if ( _initialPower < 0 )			_initialPower			= 0 ;
}
*/
