//-------------------------------------------------------------------------------------------------
// ViewBase.hpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#ifndef _include_ViewBase_
#define _include_ViewBase_


//-------------------------------------------------------------------------------------------------
// Included header files
//-------------------------------------------------------------------------------------------------
#include "Options.hpp"
#include "gameCommon.hpp"


///////////////////////////////////////////////////////////////////////////////////////////////////
//
//		ViewBase
// 
///////////////////////////////////////////////////////////////////////////////////////////////////
class ViewBase
{
private:
public:
	/// Constructors / destructors
	ViewBase();
	virtual ~ViewBase(); // destructor

	static ViewBase*	s_focusView;	// NULL if no view is currently in focus

	bool			m_isDirty;		// when true, window should be redrawn on next update
	Rgba			m_clearColor;
	IntVector2		m_mins;			// Minimum integral screen coordinate of view
	IntVector2		m_maxs;			// Maximum integral screen coordinate of view (inclusive)
	bool			m_hasFocus;		// when true, the view has focus (cursor is/was here, can process input, etc.)

	virtual void Draw();
	virtual void Update();
	void UpdateFocus( const IntVector2& cursorPos );
	void SetIsDirty( bool isDirty ) { m_isDirty = isDirty; }
	IntVector2 GetViewSize() const;
	Vector2 GetCursorPosInView() const;
	virtual bool ProcessInputEvent( TheInputSystem::inputEventType_e eventType, byte_t key );

	const Vector2 GetMousePosViewClientAbsoluteFloat() const;
	const IntVector2 GetMousePosViewClientAbsolute() const;
};


#endif // _include_ViewBase_
