//-------------------------------------------------------------------------------------------------
// ViewTexture.cpp (game)
// 
// Copyright 2004 ALGDS, Zero Lodge.  See Engine/License.hpp for usage and license details.
//-------------------------------------------------------------------------------------------------
#include "pch.hpp"
#include "ViewTexture.hpp"


//-------------------------------------------------------------------------------------------------
// Destructor()
//-------------------------------------------------------------------------------------------------
ViewTexture::~ViewTexture()
{
}


//-------------------------------------------------------------------------------------------------
// Constructor
//-------------------------------------------------------------------------------------------------
ViewTexture::ViewTexture()
{
	theConsole.Printf( "Constructing ViewTexture #%u\n", (unsigned int) this );
	m_clearColor = Rgba::DARKORANGE;
}



//-------------------------------------------------------------------------------------------------
// Draw
//-------------------------------------------------------------------------------------------------
void ViewTexture::Draw()
{
	/// Do nothing if window does not require redrawing
	if( !m_isDirty )
	{
		return;
	}

	Rgba clearColor = m_clearColor;
	clearColor *= 0.5f;
	theRenderer.ClearScreen( clearColor );

	static float voob = 0.0f;
	voob += 0.011f;
	float voobX = (float) cos( voob );
	float voobY = (float) sin( voob );

	theRenderer.SetCoordinateSystem2d( Vector2::ZERO, Vector2::ONE );
	theRenderer.TranslateCoordinateSystem2d( Vector2( voobX, voobY ) );
	theRenderer.RotateCoordinateSystem2d( voob * 0.37f );
	theRenderer.SetColor( Rgba::DARKRED );
	glLineWidth( 5.0f );
	glBegin( GL_LINE_LOOP );
	{
		glVertex2f( 0.0f, 0.0f );
		glVertex2f( 1.0f, 0.0f );
		glVertex2f( 1.0f, 1.0f );
		glVertex2f( 0.0f, 1.0f );
		glVertex2f( 0.0f, 0.0f );

		glVertex2f( -1.1f, 1.2f );
		glVertex2f( -0.1f, 0.6f );
		glVertex2f( 1.1f, -0.2f );
		glVertex2f( 1.0f, -1.0f );
		glVertex2f( -1.0f, -1.0f );
	}
	glEnd(); // GL_LINE_LOOP

	Vector2 topLeft( 0.0f, (float)(m_maxs.y - m_mins.y) );
	Vector2 bottomRight( (float)(m_maxs.x - m_mins.x), 0.0f );
	theRenderer.SetCoordinateSystem2d( topLeft, bottomRight );
	theRenderer.XYPrintf( 0.0f, 0.0f, Rgba::WHITE, "ViewTexture" );
}


